//
//  SuggestionsViewController.swift
//  VKExt
//
//  Created programmist_NA on 12.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class SuggestionsViewController: UIBaseTableViewController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, SuggestionsViewProtocol {
	var presenter: SuggestionsPresenterProtocol?
    private var feedViewModel = FeedViewModel.init(cells: [], footerTitle: nil)
    private lazy var footerView = FooterView()

	override func viewDidLoad() {
        super.viewDidLoad()
        prepareTabItem()
        prepareSpace()
        SuggestionsRouter.createModule(self)
        presenter?.start(request: .getSuggestions)
        setupTable()
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) { }
    
    // Настройка таблицы
    func setupTable() {
        topOffset?.constant = getCommonInset(by: [.statusbar]) + 8
        mainTable.backgroundColor = .adaptableWhite
        mainTable.register(SuggestionCell.self, forCellReuseIdentifier: SuggestionCell.reuseId)
        mainTable.tableFooterView = footerView
        mainTable.keyboardDismissMode = .onDrag
        mainTable.allowsMultipleSelection = false
        mainTable.allowsMultipleSelectionDuringEditing = true
        mainTable.separatorStyle = .none
        mainTable.delegate = self
        mainTable.dataSource = self
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: .valueChanged)
    }
    
    func initialFooter() { }
    
    @objc func refreshTable(_ sender: Any?) {
        presenter?.start(request: Newsfeed.Model.Request.RequestType.getNewsfeed)
    }
    
    func reloadData() {
        mainTable.reloadData()
    }
    
    func displayData(viewModel: Newsfeed.Model.ViewModel.ViewModelData) {
        switch viewModel {
        case .displayNewsfeed(let feedViewModel):
            self.feedViewModel = feedViewModel
            footerView.setTitle(feedViewModel.footerTitle)
            mainTable.reloadData()
            refreshControl.endRefreshing()
            mainTable.backgroundColor = .adaptableBackground
        case .displayFooterLoader:
            footerView.showLoader()
        default:
            break
        }
    }
    
    func scrollViewDidEndDragging(_ scrollView: UIScrollView, willDecelerate decelerate: Bool) {
        if scrollView.contentOffset.y > scrollView.contentSize.height / 1.1 {
            presenter?.start(request: Newsfeed.Model.Request.RequestType.getNextBatch)
        }
    }

    fileprivate func prepareTabItem() {
        tabItem.title = "Интересное"
        tabItem.setTabItemColor(.adaptableBlack, for: .selected)
        tabItem.setTabItemColor(.adaptableDarkGrayVK, for: .normal)
        tabItem.titleLabel?.font = GoogleSansFont.medium(with: 17)
    }
}
extension SuggestionsViewController: UITableViewDelegate, UITableViewDataSource, SuggestionCellDelegate {
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return feedViewModel.cells.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: SuggestionCell.reuseId, for: indexPath) as! SuggestionCell
        let cellViewModel = feedViewModel.cells[indexPath.row]
        cell.set(viewModel: cellViewModel)
        cell.delegate = self
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        let cellViewModel = feedViewModel.cells[indexPath.row]
        return cellViewModel.sizes.totalHeight
    }
    
    func tableView(_ tableView: UITableView, estimatedHeightForRowAt indexPath: IndexPath) -> CGFloat {
        let cellViewModel = feedViewModel.cells[indexPath.row]
        return cellViewModel.sizes.totalHeight
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    // MARK: SuggestionCellDelegate
    
    func likePost(for cell: SuggestionCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let count = feedViewModel.cells[indexPath.row].likes?.intValue
        let newCount = (count ?? 0) + 1
        feedViewModel.cells[indexPath.row].likes = newCount.stringValue
        feedViewModel.cells[indexPath.row].userLikes = 1
        cell.set(viewModel: feedViewModel.cells[indexPath.row])
        presenter?.onLikePost(request: Newsfeed.Model.Request.RequestType.like(postId: feedViewModel.cells[indexPath.row].postId, sourceId: feedViewModel.cells[indexPath.row].sourceId, type: feedViewModel.cells[indexPath.row].type))
    }
    
    func unlikePost(for cell: SuggestionCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let count = feedViewModel.cells[indexPath.row].likes?.intValue
        let newCount = (count ?? 0) - 1
        feedViewModel.cells[indexPath.row].likes = newCount == 0 ? "" : newCount.stringValue
        feedViewModel.cells[indexPath.row].userLikes = 0
        cell.set(viewModel: feedViewModel.cells[indexPath.row])
        presenter?.onLikePost(request: Newsfeed.Model.Request.RequestType.unlike(postId: feedViewModel.cells[indexPath.row].postId, sourceId: feedViewModel.cells[indexPath.row].sourceId, type: feedViewModel.cells[indexPath.row].type))
    }
    
}
